require "spec_helper"
require "stuka/commands/stuka_cli"
require 'fileutils'

describe "new command" do

  context "when project doesn't exist" do

    around(:each) do |example|
      FileUtils.rm_rf('test_pro')
      example.run
      FileUtils.rm_rf('test_pro')
    end

    it "creates a project" do
      expect { Stuka::StukaCli.start ["new", "test_pro"] }.to output(%r|create  Gemfile|).to_stdout
    end

  end

  context "when project already exists" do

    before(:each) do
      Stuka::StukaCli.start ["new", "test_pro"]
    end

    after(:each) do
      FileUtils.rm_rf('test_pro')
    end

    it "creates a project" do
      expect { Stuka::StukaCli.start ["new", "test_pro"] }.to output(%r|already exists|).to_stdout
    end

  end

end