require "spec_helper"
require "stuka/commands/stuka_cli"
require 'fileutils'

describe "process file command" do

  around(:each) do |example|
    Stuka::StukaCli.start ["new", "test_pro"]
    example.run
    FileUtils.rm_rf 'test_pro'
    FileUtils.rm_rf Dir["#{Stuka::StukaPaths.processes_definition_path}/test_process.rb"]
  end

  it "sets up the project" do
    Dir.chdir "test_pro" do
      expect { Stuka::StukaCli.start ["process", "test_process"] }.to output(%r|create  .*/processes_dsl_test/test_process.rb|).to_stdout
      
      definition_files = Dir["#{Stuka::StukaPaths.processes_definition_path}/**/*.rb"]
      expect { definition_files.to include("#{Stuka::StukaPaths.processes_definition_path}/test_process.rb}") }
    end
  end

end