require 'spec_helper'
require "stuka/external/business_action"
require_relative 'actions/cat/check_food'

describe "CheckFood" do

  let(:process) { double(transition: nil, can_transition_to?: true) }
  let(:outstream)  { StringIO.new }
  let(:action) { Actions::Cat::CheckFood.new(process) }

  after :each do
    outstream.close
  end

  it "calls the process if it succeeds" do

    expect(process).to receive :transition
    action.run({name: "George", outstream: outstream})
    expect(outstream.string).to include "There is enaugh food"

  end


end