require 'spec_helper'
require 'stuka/external/business_process'
require_relative 'processes/feed_cat_process'

describe "Feed cat process" do

  before :each do
    Stuka::StukaPaths::PROCESSES_SOURCE_PATH.replace "#{File.dirname(__FILE__)}/processes"
    Stuka::StukaPaths::ACTIONS_SOURCE_PATH.replace "#{File.dirname(__FILE__)}/actions"
  end

  let(:process) do

    FeedCatProcess.new({})

  end

  let(:outstream)  { StringIO.new }
  
  after :each do
    outstream.close
  end

  it "process starts executing actions when it ran" do

    expect(process.current_state).to eq(Stuka::External::BusinessProcess::PROCESS_STATES[:inactive])
  
    process.run({name: "George", outstream: outstream}) do |on|
      
      on.success { |params|
        params[:outstream].puts "yay success"
      }
      
      on.failure { |params|
        params[:outstream].puts "nay failure"
      }

    end

    expect(process.current_state).to eq(Stuka::External::BusinessProcess::PROCESS_STATES[:finished])

    expect(outstream.string).to include "There is enaugh food\nGeorge's food plate filled up\nyay success\n"

  end


end