require "spec_helper"
require_relative "example_source/processes/create_world"
require "stuka/external/business_process"

describe "ExampleProcess" do

  let(:dispatcher) { double(success: "", failure: "", can_end_with?: true) }
  let(:process) do

    CreateWorld.new(dispatcher: dispatcher) do |on|

      on.success {
        puts "yay success"
      }
      on.failure {
        puts "nay failure"
      }
      
    end

  end

  before :each do
    Stuka::StukaPaths::PROCESSES_SOURCE_PATH.replace "#{File.dirname(__FILE__)}/example_source"
    Stuka::StukaPaths::ACTIONS_SOURCE_PATH.replace "#{File.dirname(__FILE__)}/example_source/actions"
  end

  it "notifies the dispatcher of any other end event" do
    expect(dispatcher).to receive(:can_end_with?).with(:failure)
    expect(dispatcher).to receive(:call).with(:failure, {})
    process.run({})

    expect(process.current_state).to eq(Stuka::External::BusinessProcess::PROCESS_STATES[:finished])
  end

end
