require "spec_helper"
require "stuka/internal/process_cleaner"
require "stuka/internal/source_builders/process_builder"

describe "ProcessCleaner" do

  around(:each) do |example|
    FileUtils.rm_rf("#{Stuka::StukaPaths::TEST_PROCESSES_SOURCE_PATH}/.", secure: true)
    FileUtils.rm_rf("#{Stuka::StukaPaths::TEST_ACTIONS_SOURCE_PATH}/.", secure: true)
    example.run
    FileUtils.rm_rf("#{Stuka::StukaPaths::TEST_PROCESSES_SOURCE_PATH}/.", secure: true)
    FileUtils.rm_rf("#{Stuka::StukaPaths::TEST_ACTIONS_SOURCE_PATH}/.", secure: true)
  end

  it "deletes ruby source with ProcessCleaner::clean" do
    Stuka::ProcessBuilder.build
    Stuka::ProcessCleaner.clean
    source_files = Dir["#{Stuka::StukaPaths::TEST_PROCESSES_SOURCE_PATH}/*.rb"]
    expect(source_files.count).to eq(0)
  end

end